#include <sysdefs.h>
#include <sm_int.h>



struct elem_t {
    int 	e;		// the element
    link_t 	link;		// the link

    elem_t(int ee) : e(ee)  {};
};


//
//  A list of elem_t.
//
list_t<elem_t> a_list(offsetof(elem_t, link));

main()
{
    //
    //  Inserts 1-20 into a_list
    //
    for (int i = 1; i <= 20; i++) {
	a_list.append(new elem_t(i));
    }

    //
    //  Scans and print a_list
    //
    {
	list_i<elem_t> iter(a_list);

	for (i = 1; iter.next(); i++) {
	    cout << i << " -- " << iter.curr()->e << endl;
	}
    }

    //
    //  Removes all odd integers
    //
    {
	list_i<elem_t> iter(a_list);
	elem_t* p = 0;
	while (iter.next())  {
	    if (p) {
		delete (p->detach());
		p = 0;
	    }
	    if (iter.curr()->e % 2) {
		p = iter.curr();
	    }
	}

	if (p) {
	    delete (p->detach());
	}
    }

    //
    //  Insert 0 at the beginning of the list, and 21 at the end of
    //  the list
    //
    a_list.push(new elem_t(0)).append(new elem_t(21));

    //
    //  Removes 0 and 21
    //
    delete a_list.pop();
    delete a_list.chop();


    //
    //  Empty the list
    //
    while (a_list.top()) {
	delete a_list.pop();
    }
}
    
