/*
 *	Mutex 
 */
class smutex_t : public Mutex {
    friend class scond_t;
public:
    const char* const desc;
    smutex_t(const char* const n = 0);
    ~smutex_t();
    void acquire();
    void release();
    
    sthread_t* held_by() const	{ return locked? holder : 0; }
    
    is_locked() const		{ return locked; }
    is_hot() const		{ return this->waiters ? 1 : 0; }
    is_mine() const;

private:
    sthread_t* holder;

    // disabled --- no definition
    smutex_t(const smutex_t&);
    smutex_t& operator=(const smutex_t&);
};



/*
 *	Condition variable
 */
class scond_t: public Condition {
public:
    const char* const desc;
    scond_t(const char* const n = 0);
    ~scond_t();
    
    is_hot()		{ return this->waiters ? 1 : 0; }
    
    void wait(smutex_t *);
    void wait(smon_t *);
    void signal();
    void broadcast();
private:
    // disabled  --- no definition
    scond_t(const scond_t&);
    scond_t& operator=(const scond_t&);
};

