/* --------------------------------------------------------------- */
/* -- Copyright (c) 1994, 1995 Computer Sciences Department,    -- */
/* -- University of Wisconsin-Madison, subject to the terms     -- */
/* -- and conditions given in the file COPYRIGHT.  All Rights   -- */
/* -- Reserved.                                                 -- */
/* --------------------------------------------------------------- */

/*
 *  $Id: fixed_m.h,v 1.85 1996/09/04 18:59:34 nhall Exp $
 */
#ifndef PLAIN_M_H
#define PLAIN_M_H

#ifdef __GNUG__
#pragma interface
#endif

#include "fixed_m.h"

class plain_m : protected fixed_m {

    public:

      plain_m() { } 
      ~plain_m() { } 

      static rc_t create(
                      stid_t              stid, 
                      lpid_t&             first_page,
                      int4                record_size) ;

      static rc_t next_page(  
                      const lpid_t&       curr_pid,
                      lpid_t&             pid,
                      bool&               eof,
                      bool                lock,
                      pid_cache_t*        cache ) ; 

      static rc_t append_rec( 
                     stid_t               fid,
                     sdesc_t&             sd,
                     const vec_t&         data,
                     fixed_p&             last_page,
                     rid_t&               rid ) ;

    protected :

       static rc_t _alloc_data_page(
                     stid_t               fid,
                     int4                 record_size,
                     const lpid_t         near,
                     lpid_t&              pageid) ;

    private:

       // disabled
       plain_m(const plain_m&);
       operator=(const plain_m&);
} ;

#endif 
